<?php

/*********************************************************************

 freo | 関連データ | アルバム (2014/08/12)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* 関連データ */
function freo_associate_plugin_album($mode, $data)
{
	global $freo;

	if ($mode == 'get') {
		return freo_associate_plugin_album_get($data);
	} elseif ($mode == 'post') {
		freo_associate_plugin_album_post($data);
	} elseif ($mode == 'delete') {
		freo_associate_plugin_album_delete($data);
	}

	return;
}

/* 関連データ取得 */
function freo_associate_plugin_album_get($plugin_albums)
{
	global $freo;

	if (empty($plugin_albums)) {
		return array();
	}

	//データ初期化
	$associates = array();
	foreach ($plugin_albums as $plugin_album) {
		$associates[$plugin_album] = array();
	}

	$plugin_albums = array_map('intval', $plugin_albums);

	//グループ情報取得
	$stmt = $freo->pdo->query('SELECT group_id, album_id FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_group_sets WHERE album_id IN(' . implode(',', $plugin_albums) . ')');
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	while ($data = $stmt->fetch(PDO::FETCH_NUM)) {
		$associates[$data[1]]['group'][$data[0]] = true;
	}

	//フィルター情報取得
	$stmt = $freo->pdo->query('SELECT filter_id, album_id FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_filter_sets WHERE album_id IN(' . implode(',', $plugin_albums) . ')');
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	while ($data = $stmt->fetch(PDO::FETCH_NUM)) {
		$associates[$data[1]]['filter'][$data[0]] = true;
	}

	return $associates;
}

/* 関連データ登録 */
function freo_associate_plugin_album_post($associates)
{
	global $freo;

	if (empty($associates)) {
		return;
	}

	//グループ登録
	$stmt = $freo->pdo->prepare('DELETE FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_group_sets WHERE album_id = :id');
	$stmt->bindValue(':id', $associates['id'], PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	if (isset($associates['group'])) {
		$stmt = $freo->pdo->prepare('INSERT INTO ' . FREO_DATABASE_PREFIX . 'plugin_album_group_sets VALUES(:group_id, NULL, :associate_id)');

		foreach ($associates['group'] as $group_id => $value) {
			if ($value == '') {
				continue;
			}

			$stmt->bindValue(':group_id',     $group_id);
			$stmt->bindValue(':associate_id', $associates['id']);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}
		}
	}

	//フィルター登録
	$stmt = $freo->pdo->prepare('DELETE FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_filter_sets WHERE album_id = :id');
	$stmt->bindValue(':id', $associates['id'], PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	if (isset($associates['filter'])) {
		$stmt = $freo->pdo->prepare('INSERT INTO ' . FREO_DATABASE_PREFIX . 'plugin_album_filter_sets VALUES(:filter_id, :associate_id)');

		foreach ($associates['filter'] as $filter_id => $value) {
			if ($value == '') {
				continue;
			}

			$stmt->bindValue(':filter_id',    $filter_id);
			$stmt->bindValue(':associate_id', $associates['id']);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}
		}
	}



	return;
}

/* 関連データ削除 */
function freo_associate_plugin_album_delete($album_id)
{
	global $freo;

	if (empty($album_id)) {
		return;
	}

	//グループ削除
	$stmt = $freo->pdo->prepare('DELETE FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_group_sets WHERE album_id = :album_id');
	$stmt->bindValue(':album_id', $album_id, PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	//フィルター削除
	$stmt = $freo->pdo->prepare('DELETE FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_filter_sets WHERE album_id = :album_id');
	$stmt->bindValue(':album_id', $album_id, PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	return;
}

?>
