<?php

/*********************************************************************

 アルバムdisplayプラグイン (2018/04/11)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_display_album()
{
	global $freo;

	//パラメータ検証
	if (!isset($_GET['page']) or !preg_match('/^\d+$/', $_GET['page']) or $_GET['page'] < 1) {
		$_GET['page'] = 1;
	}

	//検索条件設定
	$condition = null;
	if (isset($_GET['word'])) {
		$condition .= ' AND title LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%') . ' OR text LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%');
	}
	if (isset($_GET['category_id'])) {
		$condition .= ' AND category_id = ' . $freo->pdo->quote($_GET['category_id']);
	}
	if (isset($_GET['tag'])) {
		$condition .= ' AND tag = ' . $freo->pdo->quote($_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote($_GET['tag'] . ',%') . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag'] . ',%');
	}
	if (isset($_GET['date'])) {
		if (preg_match('/^\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m%d\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m%d\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		}
	}

	if ($condition) {
		$condition = ' WHERE id IS NOT NULL ' . $condition;
	}

	//検索条件
	$ascending = false;

		if ($freo->config['plugin']['album']['album_order'] == 'ascend') {
			$ascending = true;
		}

	if ($ascending == true) {
		$order = ' id';
	} else {
		$order = ' id DESC';
	}
	
	//アルバム取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_albums ' . $condition . ' ORDER BY' . $order . ' LIMIT :start, :limit');
	$stmt->bindValue(':start', intval($freo->config['plugin']['album']['utility_limit']) * ($_GET['page'] - 1), PDO::PARAM_INT);
	$stmt->bindValue(':limit', intval($freo->config['plugin']['album']['utility_limit']), PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_albums = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_albums[$data['id']] = $data;
	}

	//アルバムID取得
	$plugin_album_keys = array_keys($plugin_albums);

	//アルバムタグ取得
	$plugin_album_tags = array();
	foreach ($plugin_album_keys as $plugin_album) {
		if (!$plugin_albums[$plugin_album]['tag']) {
			continue;
		}

		$plugin_album_tags[$plugin_album] = explode(',', $plugin_albums[$plugin_album]['tag']);
	}

	//表示順
	$sort = 0;
	if ($freo->config['plugin']['album']['album_file_sort'] == 'descend') {
		$sort = 1;
	}

	//ファイル取得
	$plugin_album_files = array();
	foreach ($plugin_album_keys as $plugin_album) {
		$file_dir = FREO_FILE_DIR . 'plugins/album_files/' . $plugin_album . '/';
		$thumbnail_dir = FREO_FILE_DIR . 'plugins/album_thumbnails/' . $plugin_album . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir, $sort)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						list($width, $height, $size) = freo_file($file_dir . $data);
						if (is_file($thumbnail_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
							list($thumbnailwidth, $thumbnailheight, $thumbnailsize) = freo_file($thumbnail_dir . $data);
							$thumbnail = array(
								'name'    => $data,
								'width'   => $thumbnailwidth,
								'height'  => $thumbnailheight,
								'size'    => $thumbnailsize
							);
						} else {
							$thumbnail = array();
						}
						$plugin_album_files[$plugin_album][$matches[1]] = array(
							'name'      => $data,
							'width'     => $width,
							'height'    => $height,
							'size'      => $size,
							'thumbnail' => $thumbnail
						);
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}
	

	//アルバム数・ページ数取得
	$stmt = $freo->pdo->query('SELECT COUNT(*) FROM ' . FREO_DATABASE_PREFIX . 'plugin_albums ' . $condition);
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$data                  = $stmt->fetch(PDO::FETCH_NUM);
	$plugin_album_count = $data[0];
	$plugin_album_page  = ceil($plugin_album_count / $freo->config['plugin']['album']['utility_limit']);

	//カテゴリー取得
	$stmt = $freo->pdo->query('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_album_categories ORDER BY sort, id');
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$plugin_album_categories = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_album_categories[$data['id']] = $data;
	}

	//アルバム全件取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_albums');
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}
	$plugin_album_alls = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_album_alls[$data['id']] = $data;
	}

	//アルバム全件ID取得
	$plugin_album_all_keys = array_keys($plugin_album_alls);

	//表示順
	$sort = 0;
	if ($freo->config['plugin']['album']['album_file_sort'] == 'descend') {
		$sort = 1;
	}

	//ファイル全件取得
	$plugin_album_all_files = array();
	foreach ($plugin_album_all_keys as $plugin_album_all) {
		$file_dir = FREO_FILE_DIR . 'plugins/album_files/' . $plugin_album_all . '/';
		$thumbnail_dir = FREO_FILE_DIR . 'plugins/album_thumbnails/' . $plugin_album_all . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir, $sort)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						list($width, $height, $size) = freo_file($file_dir . $data);
						if (is_file($thumbnail_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
							list($thumbnailwidth, $thumbnailheight, $thumbnailsize) = freo_file($thumbnail_dir . $data);
							$thumbnail = array(
								'name'    => $data,
								'width'   => $thumbnailwidth,
								'height'  => $thumbnailheight,
								'size'    => $thumbnailsize
							);
						} else {
							$thumbnail = array();
						}
						$plugin_album_all_files[$plugin_album_all][$matches[1]] = array(
							'name'      => $data,
							'width'     => $width,
							'height'    => $height,
							'size'      => $size,
							'thumbnail' => $thumbnail
						);
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'                  => freo_token('create'),
		'plugin_albums'          => $plugin_albums,
		'plugin_album_tags'      => $plugin_album_tags,
		'plugin_album_files'     => $plugin_album_files,
		'plugin_album_count'     => $plugin_album_count,
		'plugin_album_page'      => $plugin_album_page,
		'plugin_album_categories'=> $plugin_album_categories,
		'plugin_albums'          => $plugin_albums,
		'plugin_album_alls'      => $plugin_album_alls,
		'plugin_album_all_files' => $plugin_album_all_files,
	));

	return;
}

?>
